//+------------------------------------------------------------------+
//|                                               100 pips a day.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double lTakeProfit = 180;
extern double sTakeProfit = 180;
extern double lTrailingStop = 30;
extern double sTrailingStop = 30;
extern color clOpenBuy = Blue;
extern color clCloseBuy = Aqua;
extern color clOpenSell = Red;
extern color clCloseSell = Violet;
extern color clModiBuy = Blue;
extern color clModiSell = Red;
extern string Name_Expert = "Generate from Gordago";
extern int Slippage = 2;
extern bool UseSound = False;
extern string NameFileSound = "alert.wav";
extern double Lots = 0.01;
bool Work=true;

// int init
double gdPoint;

int init()
  {
//----

 gdPoint = Point;
 // check if we are on a 5 digit broker
 if(Digits==3||Digits==5){
   gdPoint = gdPoint*10;
   Slippage =Slippage*10;
   
   }
   

//----
   return(0);
  }

void deinit() {
   Comment("");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
        if(Bars<100)
        {
         Print("bars less than 100");
         return(0);
        }
              if(lTakeProfit<10){
               Print("TakeProfit less than 10");
                        return(0);
                                }
                           if(sTakeProfit<10){
                               Print("TakeProfit less than 10");
                                        return(0);
                                              }

                   double diClose0=iClose(NULL,15,0);
                   double diMA1=iMA(NULL,5,166,0,MODE_SMA,PRICE_OPEN,0);
                      double diClose2=iClose(NULL,5,0);
                   double diMA3=iMA(NULL,5,34,0,MODE_SMA,PRICE_OPEN,0);

                                          if(AccountFreeMargin()<(10*Lots)){
                                          Print("We have no money. Free Margin = ", AccountFreeMargin());
                                                        return(0);
                                                                           }
               if (!ExistPositions()){
    
                                          if ((diClose0>diMA1)){
                                                 OpenBuy  ();
                                                     return(0);
                                                                }

                                                           if ((diClose0<diMA1)){
                                                                      OpenSell ();
                                                                       return(0);
                                                                                 } 
                                   
                                else //close all positions 
                                
                                  if ((diClose0<diMA1)){
                                                       return(0);
                                                                }

                                                           if ((diClose0>diMA1)){
                                                                   
                                                                       return(0);
                                                                                 } 
                                   
  {                             
 int  Ticket=OrderTicket();
 bool    Ans  =false;
 
                        Alert("Attempt to close Buy ",Ticket,". Waiting for response..");
                         RefreshRates();                        // Refresh rates
                        Ans=OrderClose(Ticket,Lots,Bid,2);      // Closing Buy
                         if (Ans==true)                         // Success :)
                         {
                                  Alert ("Closed order Buy ",Ticket);
                                                              // Exit closing loop
                         }
                                       if (Fun_Error(GetLastError())==1)      // Processing errors
                                                                    // Retrying
                                                     return;                                // Exit start()
              
 
                    // Order Sell is opened..
                                                                                                      // and there is criterion to close
                                  Alert("Attempt to close Sell ",Ticket,". Waiting for response..");
                                   RefreshRates();                        // Refresh rates
                                  Ans=OrderClose(Ticket,Lots,Ask,2);      // Closing Sell
                                   if (Ans==true)                         // Success :)
                                   {
                                            Alert ("Closed order Sell ",Ticket);
                                                                         // Exit closing loop
                                   }
                                                                  if (Fun_Error(GetLastError())==1)      // Processing errors
                                                                   
                                                                    // Retrying
                                              
                                    
 
 
 
        
                       
   
    
      
   
   
 
 return (0);
 }
 }
 
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   
}

bool ExistPositions() {
for (int i=0; i<OrdersTotal(); i++) {
if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
if (OrderSymbol()==Symbol()) {
return(True);
}
} 
} 
return(false);
}
void TrailingPositionsBuy(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol()) { 
            if (OrderType()==OP_BUY) { 
               if (Bid-OrderOpenPrice()>trailingStop*gdPoint) { 
                  if (OrderStopLoss()<Bid-trailingStop*gdPoint) 
                     ModifyStopLoss(Bid-trailingStop*gdPoint); 
               } 
            } 
         } 
      } 
   } 
} 
void TrailingPositionsSell(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol()) { 
            if (OrderType()==OP_SELL) { 
               if (OrderOpenPrice()-Ask>trailingStop*gdPoint) { 
                  if (OrderStopLoss()>Ask+trailingStop*gdPoint || 
OrderStopLoss()==0)  
                     ModifyStopLoss(Ask+trailingStop*gdPoint); 
               } 
            } 
         } 
      } 
   } 
} 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice
(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   if (fm && UseSound) PlaySound(NameFileSound); 
} 

void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = 0; 
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol
(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,0,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
   ldStop = 0; 
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol
(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,0,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 
string GetCommentForOrder() { return(Name_Expert); } 
double GetSizeLot() { return(Lots); } 
double GetTakeProfitBuy() { return(Ask+lTakeProfit*gdPoint); } 
double GetTakeProfitSell() { return(Bid-sTakeProfit*gdPoint); } 


















int Fun_Error(int Error)                        // Function of processing errors
  {
   switch(Error)
     {                                          // Not crucial errors            
      case  4: Alert("Trade server is busy. Trying once again..");
         Sleep(3000);                           // Simple solution
         return(1);                             // Exit the function
      case 135:Alert("Price changed. Trying once again..");
         RefreshRates();                        // Refresh rates
         return(1);                             // Exit the function
      case 136:Alert("No prices. Waiting for a new tick..");
         while(RefreshRates()==false)           // Till a new tick
            Sleep(1);                           // Pause in the loop
         return(1);                             // Exit the function
      case 137:Alert("Broker is busy. Trying once again..");
         Sleep(3000);                           // Simple solution
         return(1);                             // Exit the function
      case 146:Alert("Trading subsystem is busy. Trying once again..");
         Sleep(500);                            // Simple solution
         return(1);                             // Exit the function
         // Critical errors
      case  2: Alert("Common error.");
         return(0);                             // Exit the function
      case  5: Alert("Old terminal version.");
         Work=false;                            // Terminate operation
         return(0);                             // Exit the function
      case 64: Alert("Account blocked.");
         Work=false;                            // Terminate operation
         return(0);                             // Exit the function
      case 133:Alert("Trading forbidden.");
         return(0);                             // Exit the function
      case 134:Alert("Not enough money to execute operation.");
         return(0);                             // Exit the function
      default: Alert("Error occurred: ",Error);  // Other variants   
         return(0);                             // Exit the function
     }
  }